<?php
/*********************************************************************
 *                      nerveBoard Qװϳn                        *
 *                         v2.5, 09/09/2001                          *
 *                                                                   *
 *                   Copyright(c) 2000,2001 Jollen                   *
 *                      http://www.jollen.org/                       *
 *                                                                   *
 *                      Jollen <jollen@jollen.org>                   *
 *********************************************************************/

// `Ƴ]w
define(PATH, $path);
define(WWW, $www);
define(TPL, "/". $tpl);

define(POST, -128);
define(SHOWPOST, -127);
define(MAIN, -126);

// ޤJɮ: C ]w
require(PATH. "C.php");

// ޤJɮ: 3 party libraries
require(PATH. "3rdparty/FastTemplate/class.FastTemplate.php3");

function init()
{
   global $topage, $srch_author, $available_board;
   global $srch_str, $board;
   global $link;

   if (!isset($topage) || empty($topage))
      $topage = 1;

   if (isset($srch_author) && !empty($srch_author))
      $srch_str = "where nickname = '$srch_author'";

   if (!isset($available_board[$board]))
      $board = '';
}

function page()
{
   global $num_rows, $max_page, $rows_per_page;
   global $srch_str, $topage, $page_from, $page_to;
   global $link, $board;

   $query = "select count(no) from {$board}_subject $srch_str";
   $r = mysql_query($query, $link);
   list($num_rows) = mysql_fetch_row($r);

   $max_page = (int)($num_rows/$rows_per_page);
   if ($max_page*$rows_per_page != $num_rows) $max_page++;

   if ($topage < 1) $topage = 1;
   else if ($topage > $max_page) $topage = $max_page;

   $page_from = ($topage-1)*$rows_per_page;
   $page_to = $rows_per_page;
}

function query()
{
   global $srch_str, $page_from, $page_to;
   global $order;
   global $link, $board;

   $sql = array(
      "normal" => "select * from {$board}_subject $srch_str
                   order by recent_reply desc limit $page_from, $page_to",

      "hits"   => "select * from {$board}_subject $srch_str
                   order by hits desc limit $page_from, $page_to",

      "reply"  => "select * from {$board}_subject $srch_str
                   order by reply desc limit $page_from, $page_to"
   );

   if (!isset($sql[$order]))
      $order = "normal";

   return mysql_query($sql[$order], $link);
}

function time_zone($from, $to)
{
   // MDT to CST
   if ($to != "CST") {
      $t = date("U");
      $date->datetime = date("Y-m-d H:i:s", $t+50400);
      $date->timestamp = date("Y-m-d", $t+50400);
      return $date;
   } else {
      $t = date("U");
      $date->datetime = date ("Y-m-d H:i:s", $t+50400);
      $date->timestamp = date("Y-m-d", $t+50400);
      return $date;
   }
}

function inc_posts()
{
   global $mysql_database;
   global $link;
   global $userID;

   $sql = "UPDATE {$mysql_database}.member SET posts = posts + 1
           WHERE no = $userID->no";
   mysql_query($sql);
   
   $userID->posts = $userID->posts + 1;
}

function get_level($uid)
{
   if (isset($uid)) return 1;
   return 0;
}

function get_level_color($level)
{
   switch ($level)
   {
      case 0: return '#000000';
      case 1: return '#FF00FF';
      default: return '#000000';
   }
}

function nerveBoard($action = NULL)
{
   if ($action == POST) nerveBoard_post();
   else if ($action == SHOWPOST) nerveBoard_showpost();
   else nerveBoard_main();
}

function nerveBoard_main($board = NULL)
{
   global $STYLE;
   global $available_board;
   global $default_board;
   global $link;
   global $topage;              //needed by C_header()
   global $srch_author;         //needed by C_header()
   global $max_page;            //needed by C_header()
   global $order;               //needed by C_header()
   global $board;

   //1. FastTemplate 
   $tpl = new FastTemplate(PATH. "templates". TPL);

   //2.wq Template W & ʺA˪O
   $tpl->define(array(main => "index.tpl"));
   $tpl->define_dynamic("row", "main");

   if (!isset($available_board[$board]) || empty($board))
      $board = $default_board;

   //ܼƪl & Connect to MySQL
   init();

   //pŦX峹` & lƤܼ
   page();

   C_header();

   // SQL & Query X
   $r = query();

   while ($row = mysql_fetch_object($r)) 
   {
      $reply_date = ($row->reply) ? $row->recent_reply : "X";

      $p = $row->postdate;
      $post_date = $p[0].$p[1].$p[2].$p[3].'-'.$p[4].$p[5].'-'.$p[6].$p[7];

      $showpost = "<a href=showpost.php?no=$row->no&subject=". urlencode("$row->subject"). "&board=$board&topage=$topage>$row->subject</a>";

      //|
      $level = get_level_color($row->level);
   
      //3.wܼƭ
      $tpl->assign(NICKNAME, "<font color=\"$level\">$row->nickname</font>");
      $tpl->assign(POSTDATE, $post_date);
      $tpl->assign(SUBJECT,  $showpost);
      $tpl->assign(HITS,     $row->hits);
      $tpl->assign(REPLY,    $row->reply);
      $tpl->assign(RECENT,   $reply_date);

      //4.ʺA˪OR
      $tpl->parse(ROWS, ".row");
   }

   //6.˪OR
   $tpl->assign(STYLE_TABLE,   $STYLE[table]);
   $tpl->parse(BODY, "main");

   //7.LX
   $tpl->FastPrint("BODY");

   C_footer();
}

function nerveBoard_threads()
{
   global $STYLE;
   global $available_board;
   global $link;
   global $topage;              //needed by C_header()
   global $srch_author;         //needed by C_header()
   global $max_page;            //needed by C_header()
   global $order;               //needed by C_header()
   global $board;

   //1. FastTemplate 
   $tpl = new FastTemplate(PATH. "templates". TPL);

   //2.wq Template W & ʺA˪O
   $tpl->define(array(main => "threads.tpl"));
   $tpl->define_dynamic("row", "main");

   //ܼƪl & Connect to MySQL
   init();

   //pŦX峹` & lƤܼ
   page();

   C_header();

   // SQL & Query X
   $r = query();

   while ($row = mysql_fetch_object($r)) 
   {
      $reply_date = ($row->reply) ? $row->recent_reply : "X";

      $p = $row->postdate;
      $post_date = $p[0].$p[1].$p[2].$p[3].'-'.$p[4].$p[5].'-'.$p[6].$p[7];
      $today = date("Ymd");

      //O_BsDD
      $tips = "";
      if ($row->postdate >= $today)  
      {
         //if ($row->hits > 35) $tips = "<font color=#ff0000>HOT!</font>";
         if (!empty($top)) $top .= "<br>";
         $tips .= "<font color=#ff0000>NEW</font>";
      }

      $url = "showpost.php?no=$row->no&subject=". urlencode("$row->subject"). "&board=$board&topage=$topage";
      $showpost = "<a href=\"{$url}\">$row->subject</a>";

      if (empty($tips)) $tips = "@";	//Ƶe

      //3.wܼƭ
      $tpl->assign(NICKNAME, $row->nickname);
      $tpl->assign(POSTDATE, $post_date);
      $tpl->assign(SUBJECT,  $showpost);
      $tpl->assign(HITS,     $row->hits);
      $tpl->assign(TIPS,     $tips);
      $tpl->assign(REPLY,    $row->reply);
      $tpl->assign(RECENT,   $reply_date);

      //ŪsW^ (threads)
      $sql = "SELECT nickname,postdate FROM {$board}_content 
              WHERE main='$row->no' and postdate >= '$today' 
              ORDER BY postdate";
      $r2 = mysql_query($sql, $link) or die("MySQL error: 0xFB, $sql");
      $count = mysql_num_rows($r2);

      $count = $row->reply-$count+1;

      $thread = "";
      mysql_fetch_row($r2);		//h

      while ($row->reply && list($nickname, $postdate) = mysql_fetch_row($r2))
      {
         $thread = "New:&nbsp;<a href=\"{$url}#thread{$count}\">$postdate, $nickname</a><br>".$thread;
         $count++;
      }

      $tpl->assign(THREAD, $thread);

      //4.ʺA˪OR
      $tpl->parse(ROWS, ".row");
   }

   //6.˪OR
   $tpl->assign(STYLE_TABLE,   $STYLE[table]);
   $tpl->parse(BODY, "main");

   //7.LX
   $tpl->FastPrint("BODY");

   C_footer();
}

function nerveBoard_post()
{
   global $link;
   global $subject;
   global $nickname;
   global $message;
   global $check;
   global $email;
   global $homepage_name;
   global $homepage_url;
   global $no;
   global $postdate;
   global $available_board;
   global $board;
   global $sex;
   global $emotion;
   global $REMOTE_ADDR;
   global $topage;		//needed by C_header()
   global $srch_author;		//needed by C_header()
   global $max_page;		//needed by C_header()
   global $order;		//needed by C_header()
   global $TIME_ZONE;		//
   global $userID;
   global $allow_html;

   //ˬduDDvBuʺ١vPudvO_ť (newpost & reply)C
   if (!empty($subject) &&  !empty($nickname) && !empty($message) && 
       $check == "true") {
 
      init();
      page();
      C_header(POST);

      //h HTML yk
      $nickname = ereg_replace("<[^>]*>", "", $nickname);
      $subject  = ereg_replace("<[^>]*>", "", $subject);
      if ($allow_html != "1") {
         //$message  = ereg_replace("<[^>]*>", "", $message);
         $message  = ereg_replace("<", "&lt;", $message);
         $message  = ereg_replace(">", "&gt;", $message);
      }
      $message  = ereg_replace(" ", "&nbsp;", $message);
      $email    = ereg_replace("<[^>]*>", "", $email);
      $homepage_name = ereg_replace("<[^>]*>", "", $homepage_name);
      $homepage_url  = ereg_replace("<[^>]*>", "", $homepage_url);

      //$no = -1 ܱiKs峹A][JDDC
      if ($no == "-1") 
      {
         //OoP_ɰ
         $date = time_zone(date("T"), $TIME_ZONE);

         //Bz|
         $level = get_level($userID);

         $sql = "insert into {$board}_subject 
                 (nickname, subject, hits, reply, level, postdate,
                  recent_reply)
                 values ('$nickname', '$subject', 0, 0, $level, 
                 '$date->timestamp', '$date->datetime')";

         mysql_query($sql, $link) or die("MySQL error: nerveBoard_post() 0x03");
      }

      //[JdApG $no = -1AܱiKs峹C
      if ($no == "-1") 
      {
         $sql = "select no from {$board}_subject where nickname = '$nickname' 
                 and subject = '$subject'";
         $result = mysql_query($sql, $link) or die("MySQL error: nerveBoard_post() 0x01");
         list($no) = mysql_fetch_row($result);
      } 
      else 
      {
         //OoP_ɰ
         $date = time_zone(date("T"), $TIME_ZONE);

         //OiKsiA]O^AҥHnW[^ơC
         $sql = "update {$board}_subject set reply = reply+1, 
                 recent_reply = '$date->datetime',
                 postdate = postdate where no = $no";
         mysql_query($sql, $link) or die("MySQL error: $sql");
      }

      //OoP_ɰ
      $date = time_zone(date("T"), $TIME_ZONE);

      //[J IP
      //$message .= "<p>$REMOTE_ADDR</p>";

      //Bz|
      $level = get_level($userID);

      $sql = "insert into {$board}_content (main, postdate, nickname, sex, 
              email, homepage_name, homepage_url, emotion, message, level)
              values
              ($no, '$date->datetime', '$nickname', '$sex', '$email', 
              '$homepage_name', '$homepage_url', $emotion, '$message', 
              $level)";

      mysql_query($sql, $link) or die("MySQL error: nerveBoard_post() 0x02, $sql");
      inc_posts();		//W[|峹g

      echo "<p>峹wiKܡG<a href=".WWW."index.php?board=$board>{$available_board[$board][name]}</a>I</p>";
   }  else {	// newpost or ި^
      C_post();
      C_footer();
   }
}

function nerveBoard_showpost()
{
   global $no;
   global $subject;
   global $link;
   global $board;

   C_header(SHOWPOST);

   // FastTemplate 
   $tpl = new FastTemplate(PATH. "templates". TPL);

   //wq Template W & ʺA˪O
   $tpl->define(array(main => "showpost.tpl"));
  
   $tpl->define_dynamic("row", "main");

   //lưQ׸s
   init();

   $sql = "select * from {$board}_content where main=$no order by postdate";
   $r = mysql_query($sql, $link);

   $thread = 0;

   //CXҦŦX󪺤
   while ($row = mysql_fetch_object($r)) 
   {
      //NŸܧ HTML yk
      $message = nl2br($row->message);

      //Nbd IP h
      $message = ereg_replace("<p>.*\..*\..*\..*</p>", "", $message);

      //ϥܳ]w
      $emotion_pic = "<img src=".WWW."images/$row->sex$row->emotion.gif>";

      //]wʺCAOdH᪺ϥΪ̤ŨϥΡC
      $level = get_level_color($row->level);
      $nickname = "<font color=$level>$row->nickname</font>";

      //pGdU E-MailAsP E-Mail @_ܡC
      if (!empty($row->email))
         $nickname .= " <a href=mailto:$row->email><img src=".WWW."images/email.gif border=0 align=absmiddle></a>";

      //^r
      $reply_str = "<div><font size=1><a href=\"post.php?no=$no&postdate=$row->postdate&subject=".urlencode($subject)."&nickname=".urlencode($row->nickname)."&board=".urlencode($board)."\">ި^</a></font></font>"; 
 
      //thread r
      $thread_line = "<a name=\"thread$thread\">";

      //wܼƪȵ FastTemplate
      $tpl->assign(THREAD,  $thread_line);
      $tpl->assign(SUBJECT,  $subject);
      $tpl->assign(POSTDATE, $row->postdate);
      $tpl->assign(NICKNAME, $nickname);
      $tpl->assign(MESSAGE,  $message);
      $tpl->assign(EMOTION,  $emotion_pic);
      $tpl->assign(REPLY_STRING, $reply_str);

      //RʺA˪O϶
      $tpl->parse(ROWS, ".row");

      $thread++;
   }

   $tpl->parse(BODY, "main");
   $tpl->FastPrint("BODY");

   //W[H 1 I 
   $sql = "update {$board}_subject set hits = hits+1, postdate = postdate
           where no = $no";
   mysql_query($sql, $link);

   C_post();
   C_footer();
}
?>
