CREATE TABLE board_subject 
(
   no            smallint NOT NULL AUTO_INCREMENT,
   nickname      varchar(32) NOT NULL,
   postdate      timestamp(8) NOT NULL,
   subject       varchar(64) NOT NULL,
   hits          smallint NOT NULL,
   reply         smallint NOT NULL,
   level         smallint NOT NULL DEFAULT 0,
   recent_reply  datetime,
   primary key(no)
);

CREATE TABLE board_content 
(
   main		 smallint NOT NULL,
   postdate 	 datetime NOT NULL,
   nickname 	 varchar(32) NOT NULL,
   sex 		 enum("M", "F") DEFAULT "M",
   level 	 smallint NOT NULL DEFAULT 0,
   email 	 varchar(64),
   homepage_name varchar(32),
   homepage_url  varchar(64),
   emotion 	 tinyint NOT NULL,
   message 	 blob NOT NULL
);
